package yhg.comm.server;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import yhg.comm.message.Message;

/**
 * 
 * 
 * @author	Yoon HyunGook
 * @since	2010-03-08
 */
public class CommServer extends Thread {
	private List<CommClientManager> clientList = Collections.synchronizedList(new ArrayList<CommClientManager>());
	private ServerSocket server;
	private ICommClientManagerEvent clientEvent;
	private ICommServerEvent serverEvent;
	
	/**
	 * 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	Ʈ
	 */
	public CommServer(int port) throws IOException {
		server = new ServerSocket(port);
	}
	
	/**
	 * Ŭ̾Ʈ Ŵ ̺Ʈ 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	̺Ʈ
	 */
	public void setClientManagerEvent(ICommClientManagerEvent rec){
		clientEvent = rec;
	}
	
	/**
	 *  ̺Ʈ 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	̺Ʈ
	 */
	public void setServerEvent(ICommServerEvent apt){
		serverEvent = apt;
	}
	
	/**
	 *  
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 */
	public void run(){
		System.out.println("-- start server --");
		
		while(true){
			try {
				final Socket clientSock = server.accept();
				CommClientManager client = new CommClientManager(this,clientSock);
				clientList.add(client);
				
				serverEvent.onEnterClient(client);
				
				client.setClientManagerEvent(clientEvent);
				client.start();
			} catch (IOException e) {
				try {
					server.close();
					System.out.println("-- close server --");
				} catch (IOException e1) {
					e1.printStackTrace();
				}
			}
		}
	}
	
	/**
	 *   Ŭ̾Ʈ ޼ 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	޼
	 */
	public void sendAll(Message msg) throws IOException{
		for(int i=0; i<clientList.size(); i++){
			clientList.get(i).send(msg);
		}
	}
	
	/**
	 *  Ŭ̾Ʈ   Ŭ̾Ʈ ޼ 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	 Ŭ̾Ʈ ȣ
	 * @param	޼
	 */
	public void sendAll(int num, Message msg) throws IOException{
		for(int i=0; i<clientList.size(); i++){
			if(i == num)	continue;
			
			clientList.get(i).send(msg);
		}
	}
	
	/**
	 *  Ŭ̾ƮԸ ޼ 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	Ŭ̾Ʈ ȣ
	 * @param	޼
	 */
	public void sendTo(int num, Message msg) throws IOException{
		clientList.get(num).send(msg);
	}
	
	/**
	 * CommClientManager ü Ŭ̾Ʈ ȣ 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	CommClientManager ü
	 * 
	 * @return	Ŭ̾Ʈ ȣ
	 */
	public int getClientNumber(CommClientManager cm){
		return clientList.indexOf(cm);
	}
	
	/**
	 * Ŭ̾Ʈ   ̺Ʈ
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	CommClientManager ü
	 */
	protected void onLeaveClient(CommClientManager cm){
		serverEvent.onLeaveClient(cm);
		clientList.remove(cm);
	}
}
